//
//  MyCollectionViewController.swift
//  CollectionDemo
//
//  Created by Neil Smyth on 11/6/14.
//  Copyright (c) 2014 Neil Smyth. All rights reserved.
//

import UIKit

let reuseIdentifier = "MyCell"

class MyCollectionViewController: UICollectionViewController,
UICollectionViewDataSource, UICollectionViewDelegate  {

    var carImages = [String]()

    override func viewDidLoad() {
        super.viewDidLoad()
    let myLayout = MyFlowLayout()

    self.collectionView?.setCollectionViewLayout(myLayout,
			animated: true)

    let pinchRecognizer = UIPinchGestureRecognizer(target: self, 
			action: "handlePinch:")

    self.collectionView?.addGestureRecognizer(pinchRecognizer)


        // Uncomment the following line to preserve selection between presentations
        // self.clearsSelectionOnViewWillAppear = false

        // Do any additional setup after loading the view.
    carImages = ["chevy_small.jpg",
                "mini_small.jpg",
                "rover_small.jpg",
                "smart_small.jpg",
                "highlander_small.jpg",
                "venza_small.jpg",
                "volvo_small.jpg",
                "vw_small.jpg",
                "ford_small.jpg",
                "nissan_small.jpg",
                "honda_small.jpg",
                "jeep_small.jpg"]

    }

    func handlePinch(gesture: UIPinchGestureRecognizer) {

        let layout = self.collectionView?.collectionViewLayout
                as! MyFlowLayout

        if gesture.state == UIGestureRecognizerState.Began
        {
            // Get the initial location of the pinch?
            let initialPinchPoint = 
                gesture.locationInView(self.collectionView) 

            // Convert pinch location into a specific cell
            let pinchedCellPath = 
         self.collectionView?.indexPathForItemAtPoint(initialPinchPoint)

            // Store the indexPath to cell
            layout.currentCellPath = pinchedCellPath;
        }
        else if gesture.state == UIGestureRecognizerState.Changed
        {
            // Store the new center location of the selected cell
            layout.currentCellCenter = 
                gesture.locationInView(self.collectionView)
            // Store the scale value
            layout.setCurrentCellScale(gesture.scale)
        }
        else
        {
            self.collectionView?.performBatchUpdates({
                layout.currentCellPath = nil
                layout.currentCellScale = 1.0}, completion:nil)
        }
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepareForSegue(segue: UIStoryboardSegue, sender: AnyObject?) {
        // Get the new view controller using [segue destinationViewController].
        // Pass the selected object to the new view controller.
    }
    */

    // MARK: UICollectionViewDataSource

    override func numberOfSectionsInCollectionView(collectionView: UICollectionView) -> Int {
        return 1
    }


    override func collectionView(collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return carImages.count
    }

    override func collectionView(collectionView: UICollectionView, cellForItemAtIndexPath indexPath: NSIndexPath) -> UICollectionViewCell {
        let cell = collectionView.dequeueReusableCellWithReuseIdentifier(reuseIdentifier, forIndexPath: indexPath) as! MyCollectionViewCell
    
        // Configure the cell
	let image = UIImage(named: carImages[indexPath.row])
    	cell.imageView.image = image

    
        return cell
    }

// MARK: UICollectionViewFlowLayoutDelegate

    func collectionView(collectionView: UICollectionView,
        layout collectionViewLayout: UICollectionViewLayout,
        sizeForItemAtIndexPath indexPath: NSIndexPath) -> CGSize {

        let image = UIImage(named: carImages[indexPath.row])
        return image!.size
    }


    // MARK: UICollectionViewDelegate

    override func collectionView(collectionView: UICollectionView, didSelectItemAtIndexPath indexPath: NSIndexPath) {

        let myLayout = UICollectionViewFlowLayout()

        myLayout.scrollDirection = 
            UICollectionViewScrollDirection.Horizontal
        
        self.collectionView?.setCollectionViewLayout(myLayout, animated: true)
        
    }


override func collectionView(collectionView: UICollectionView,
    viewForSupplementaryElementOfKind kind: String,
    atIndexPath indexPath: NSIndexPath)
              -> UICollectionReusableView {

    var header: MySupplementaryView?

    if kind == UICollectionElementKindSectionHeader {
        header = 
          collectionView.dequeueReusableSupplementaryViewOfKind(kind, 
          withReuseIdentifier: "MyHeader", forIndexPath: indexPath) 
             as? MySupplementaryView

        header?.headerLabel.text = "Car Image Gallery"
    }
        return header!
}

    /*
    // Uncomment this method to specify if the specified item should be highlighted during tracking
    override func collectionView(collectionView: UICollectionView, shouldHighlightItemAtIndexPath indexPath: NSIndexPath) -> Bool {
        return true
    }
    */

    /*
    // Uncomment this method to specify if the specified item should be selected
    override func collectionView(collectionView: UICollectionView, shouldSelectItemAtIndexPath indexPath: NSIndexPath) -> Bool {
        return true
    }
    */

    /*
    // Uncomment these methods to specify if an action menu should be displayed for the specified item, and react to actions performed on the item
    override func collectionView(collectionView: UICollectionView, shouldShowMenuForItemAtIndexPath indexPath: NSIndexPath) -> Bool {
        return false
    }

    override func collectionView(collectionView: UICollectionView, canPerformAction action: Selector, forItemAtIndexPath indexPath: NSIndexPath, withSender sender: AnyObject?) -> Bool {
        return false
    }

    override func collectionView(collectionView: UICollectionView, performAction action: Selector, forItemAtIndexPath indexPath: NSIndexPath, withSender sender: AnyObject?) {
    
    }
    */

}
