//
//  Draw2D.swift
//  Draw2D
//
//  Created by Neil Smyth on 11/6/14.
//  Copyright (c) 2014 Neil Smyth. All rights reserved.
//

import UIKit

class Draw2D: UIView {

    // Only override drawRect: if you perform custom drawing.
    // An empty implementation adversely affects performance during animation.
    override func drawRect(rect: CGRect) {
        // Drawing code
        let context = UIGraphicsGetCurrentContext()

        let locations: [CGFloat] = [ 0.0, 0.25, 0.5, 0.75 ]

        let colors = [UIColor.redColor().CGColor,
                      UIColor.greenColor().CGColor,
                      UIColor.blueColor().CGColor,
                      UIColor.yellowColor().CGColor]

        let colorspace = CGColorSpaceCreateDeviceRGB()

        let gradient = CGGradientCreateWithColors(colorspace,
                      colors, locations)

        var startPoint = CGPoint()
        var endPoint =  CGPoint()

        startPoint.x = 0.0
        startPoint.y = 0.0
        endPoint.x = 600
        endPoint.y = 600

        CGContextDrawLinearGradient(context, gradient,
                   startPoint, endPoint, 0)

    }

}
